<?php
/***********************************************************************

  Copyright (C) 2007  BN (bnmaster@la-bnbox.info)

  This software is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  This software is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

// Make sure no one attempts to run this script "directly"
if (!defined('PUN'))
    exit;

// Tell profil.php that this is indeed a plugile and that it is loaded
define('PUN_PLUGIN_LOADED', 1);
define('PLUGIN_VERSION', '1.1');
define('PLUGIN_URL', 'profile.php?plugin='.$_GET['plugin'].'&amp;id='.$_GET['id']);
define('PLUGIN_NAME', $_GET['plugin']);
$tabindex = 1;

/***********************************************************************\
 Languages definitions
\***********************************************************************/
$english_array = array(
'err_1'					=> 'No uploaded file actually.',
'err_2'					=> 'No upload.',
'err_insert'			=> 'Error in the DB update',
'err_size'				=> 'The file is to big to be uploaded, try again.',
'err_extension'			=> 'This is not a good extension, try again.',
'err_extension_multiple'=> 'Please, no point (.) in your file name.',
'err_delete'			=> 'Error during the file delete, try again.',
'err_espace'			=> 'You exceed your storage space. Delete files and try again.',
'err_update'			=> 'Error in the DB update',

'delete_success'		=> 'File(s) deleted with sucess!',
'modif_success'			=> 'File uploaded!',
'uploadile'				=> 'My uploads',
'titre_1'				=> '',
'titre_2'				=> 'Upload a file',
'titre_3'				=> 'My uploads',
'info_1'				=> 'You can easyly upload files on the Web site. You can use it to divide something different of a word ;)',
'info_2'				=> '/!\ Your file must not be bigger than %sKo and must be a %s file.',
'info_2_admi'			=> '/!\ Your file must be a %s file.',
'info_3_admi'			=> '<div style="border:1px solid #4E642D; width:12em;"><div style="border-right: 2px solid #4E642D; background-color: #6C8A3F; text-align:right; width:%s%s;">%s%s</div></div><p><strong>Storage space use:</strong> %sKo in %sKo.<br /><strong>Storage folder :</strong> img/members/%s</p>',
'info_3'				=> '<p><strong>Storage folder :</strong> img/members/%s</p>',
'legend'				=> 'Select and send your file',
'fichier'				=> 'Select a file',
'fichier_name'			=> 'Modify the file name (optionnal)',
'th'					=> 'File name',
'submit'				=> 'Send',
'delete'				=> 'Delete',
);
$french_array = array(
'err_1'					=> 'Aucun fichier upload actuellement.',
'err_2'					=> 'Aucune upload.',
'err_insert'			=> 'Erreur lors de la mise  jour de la Base de donnes',
'err_size'				=> 'Fichier trop volumineux, ressayez.',
'err_extension'			=> 'Cette extension n\'est pas accept, ressayez.',
'err_extension_multiple'=> 'Le nom de votre fichier ne doit pas contenir de point (.).',
'err_espace'			=> 'Vous dpassez l\'espace qui vous est allou. Supprimer des fichiers et ressayez.',
'err_update'			=> 'Erreur lors de la mise  jour de la base de donnes.',
'err_delete'			=> 'Erreur lors de la suppression du ou des fichiers, ressayez.',

'delete_success'		=> 'Fichier(s) supprim(s) avec succs !',
'modif_success'			=> 'Fichier uplod avec succs !',
'uploadile'				=> 'Mes uploads',
'titre_1'				=> '',
'titre_2'				=> 'Uploader un fichier',
'titre_3'				=> 'Mes uploads actuelles',
'info_1'				=> 'Vous pouvez uploader facilement des fichiers sur le serveur du site. Voil qui pourra vous tre utile pour partager des informations autrement que par les mots ;)',
'info_2'				=> '/!\ Votre fichier ne doit pas dpasser les %sKo et doit tre de type : %s.',
'info_2_admi'			=> '/!\ Votre fichier doit tre de type : %s.',
'info_3_admi'			=> '<div style="border:1px solid #4E642D; width:12em;"><div style="border-right: 2px solid #4E642D; background-color: #6C8A3F; text-align:right; width:%s%s;">%s%s</div></div><p><strong>Espace utilis :</strong> %sKo sur %sKo.<br /><strong>Dossier de stockage :</strong> img/members/%s</p>',
'info_3'				=> '<p><strong>Dossier de stockage :</strong> img/members/%s</p>',
'legend'				=> 'Slctionnez et envoyer votre fichier',
'fichier'				=> 'Slctionner un fichier',
'fichier_name'			=> 'Modifier le nom du fichier (facultatif)',
'th'					=> 'Nom du fichier',
'submit'				=> 'Envoyer',
'delete'				=> 'Supprimer',
);

// Set language
if ($pun_user['language'] == 'English')
	$lang = $english_array;
elseif ($pun_user['language'] == 'French')
	$lang = $french_array;

	
// Espace allou et espace actuellement utilis et taille maximale uploadable
$retour = $db->query('SELECT id,upload FROM '.$db->prefix.'users WHERE id='.$id) or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
	message($lang_common['Bad request']);
$user_plugile = $db->fetch_assoc($retour);
if($user['g_id'] == '1')
	$limit = '100000000000';
elseif($user['g_id'] == '2')
	$limit = $pun_config['o_uploadile_limit_modo'];
else
	$limit = $pun_config['o_uploadile_limit_member'];
if($user['g_id'] == '1')
	$maxsize = '100000000000';
elseif($user['g_id'] == '2')
	$maxsize = $pun_config['o_uploadile_maxsize_modo'];
else
	$maxsize = $pun_config['o_uploadile_maxsize_member'];
$pourcentage_utilise = ceil(($user_plugile['upload']*100)/$maxsize);

// Suppresion des fichiers
if(isset($_POST['supprimer']) AND $_POST['supprimer'] != NULL)
{
	$dir = 'img/members/'.$id.'/';
	if(is_dir($dir)) // On vrifie que la valeur est un fichier (pour carter les sous dossiers)
	{
		// On supprime les images
		$erreur = 1;
		for($u = 1 ; $u <= $_POST['boucle_id'] ; $u++)
		{
			if(isset($_POST['supprimer_'.$u]) AND is_file($dir.$_POST['supprimer_'.$u]))
				$delete = unlink($dir.$_POST['supprimer_'.$u]);
			if(!$delete)
				$erreur++;
		}
		
		// On cherche la taille du dossier du membre 
		$open = opendir($dir); // On ouvre le rpertoire
		while(false !== ($file = readdir($open))) // Tant qu'il y a des fichiers  lire
		{
			if(is_file($dir.$file)) // On vrifie que la valeur est un fichier (pour carter les sous dossiers)
			{
				$extension = strtolower(substr(strrchr($file,  "." ), 1)); // On prend l'extension du fichier dans la variable $extension avec une sous-chaine
				$extsupport = explode(',', $pun_config['o_uploadile_laws'].','.strtoupper($pun_config['o_uploadile_laws'])); // La liste des extensions possibles pour une image
				if(in_array($extension, $extsupport) and ($file[0] != "#")) // Si l'extension ne figure pas dans la liste on passe le fichier (A noter: Pour cacher une image placez un "#" devant son nom et elle ne passera pas cette tape et ne sera pas liste)
					$files[] = $dir.$file; // Si elle y figure on ajoute le fichier  l'array $files
			}
		}
		closedir($open); // Et enfin on ferme le dossier
		if(isset($files))
		{
			$upload = '0';
			foreach($files as $image)
				$upload = $upload + filesize($image);
		}
		$db->query('UPDATE '.$db->prefix.'users SET upload=\''.$upload.'\' WHERE id='.$_GET['id']) or error(sprintf($lang['err_insert'],$conf_name), __FILE__, __LINE__, $db->error());
	}
	if($erreur == '1')
		redirect(PLUGIN_URL, $lang['delete_success']);
	else
		redirect(PLUGIN_URL, $lang['err_delete']);
}
// Ajout d'un fichier
elseif(isset($_FILES['fichier']) AND $_FILES['fichier'] != NULL AND $_FILES['fichier']['error'] == 0)
{
	// On vrifie les extansions
	$extension_multiple = explode('.', $_FILES['fichier']['name']); 
	if(count($extension_multiple) == '2') // Pour empcher les extensions du type blabla.php.jpg
	{
		$extensions_valides = explode(',', $pun_config['o_uploadile_laws'].','.strtoupper($pun_config['o_uploadile_laws']));
		$extension_upload = substr(strrchr($_FILES['fichier']['name'], '.'), 1);
		if(in_array($extension_upload,$extensions_valides))
		{
			// On vrifie la taille maximale
			if($_FILES['fichier']['size'] <= $maxsize)
			{
				// On vrifie l'espace allou
				if($_FILES['fichier']['size']+$user_plugile['upload'] <= $limit)
				{
					$upload = $user_plugile['upload']+$_FILES['fichier']['size'];
					if(isset($_POST['fichier_name']) AND $_POST['fichier_name'] != NULL)
					{
						$extension_multiple = explode('.', $_POST['fichier_name']); 
						if(count($extension_multiple) == '1') // Pour empcher les extensions du type blabla.php.jpg
						{
							$extension_fichier = explode('/', $_FILES['fichier']['type']);
							if($extension_fichier[count($extension_fichier)-1] == 'x-shockwave-flash')
								$extension_fichier[count($extension_fichier)-1] = 'swf';
							$fichier = $_POST['fichier_name'].'.'.$extension_fichier[1];
						}
						else
							redirect(PLUGIN_URL, $lang['err_extension_multiple']);
					}
					else
						$fichier = $_FILES['fichier']['name'];
					$fichier_name_temp = $_FILES['fichier']['tmp_name'];
					$dir = 'img/members/'.$id.'/';
					if(is_file($dir.$fichier))
						$fichier = date('dmY\-Hi', time()).'_'.$fichier;

					if(!is_dir('img/members/'))
						mkdir('img/members', 0755);
					if(!is_dir($dir))
						mkdir('img/members/'.$id, 0755);
					move_uploaded_file($fichier_name_temp,$dir.$fichier);
					$db->query('UPDATE '.$db->prefix.'users SET upload=\''.$upload.'\' WHERE id='.$_GET['id']) or error(sprintf($lang['err_insert'],$conf_name), __FILE__, __LINE__, $db->error());
					redirect(PLUGIN_URL, $lang['modif_success']);
				}
				else
					redirect(PLUGIN_URL, $lang['err_espace']);
			}
			else
				redirect(PLUGIN_URL, $lang['err_size']);
		}
		else
			redirect(PLUGIN_URL, $lang['err_extension']);
	}
	else
		redirect(PLUGIN_URL, $lang['err_extension_multiple']);
}
else
{
	generate_profile_menu(PLUGIN_NAME);
	?>
	<div id="uploadile" class="blockform">
		<h2><span><?php echo $lang['titre_1']; ?></span></h2>
		<div class="box">
			<div class="inbox">
				<p style="margin: 5px"><?php echo $lang['info_1']; ?></p>
			</div>
		</div>
		
		<h2 class="block2"><span><?php echo $lang['titre_2']; ?></span></h2>
		<div class="box">
			<form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>" enctype="multipart/form-data">
				<div class="inform">
					<fieldset>
						<legend><?php echo $lang['legend']; ?></legend>
						<div class="infldset">
							<label for="fichier"><?php echo $lang['fichier']; ?></label> <input type="file" id="fichier" name="fichier" tabindex="<?php echo $tabindex++; ?>" />
							<label for="fichier_name"><?php echo $lang['fichier_name']; ?></label> <input type="text" id="fichier_name" name="fichier_name" tabindex="<?php echo $tabindex++; ?>" />
							<p>
								<?php	
								if($user['g_id'] == '1')
									printf($lang['info_2_admi'],str_replace(',', ', ', $pun_config['o_uploadile_laws']));
								else
									printf($lang['info_2'],ceil(($maxsize*1024)/1048576),str_replace(',', ', ', $pun_config['o_uploadile_laws']));
								?>
							</p>
						</div>
					</fieldset>
				</div>
				<p><input type="submit" name="submit" value="<?php echo $lang['submit']; ?>" tabindex="<?php echo $tabindex++; ?>" /></p>
			</form>
		</div>
		
		<h2 class="block2"><span><?php echo $lang['titre_3']; ?></span></h2>
		<div class="box">
			<form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>" enctype="multipart/form-data">
				<div class="inform">
					<?php 
					if($user['g_id'] != '1')
						printf($lang['info_3_admi'], $pourcentage_utilise, '%', $pourcentage_utilise, '%', ceil(($user_plugile['upload']*1024)/1048576),ceil(($limit*1024)/1048576), $id);
					else
						printf($lang['info_3'], $id);
					?>
					<div class="infldset">
						<table class="aligntop" cellspacing="0">
							<thead>
								<tr>
									<th scope="row"><?php echo $lang['th']; ?></th>
									<th scope="row"><input type="submit" value="<?php echo $lang['delete']; ?>" name="supprimer" tabindex="<?php echo $tabindex++; ?>" /></th>
								</tr>
							</thead>
							<tfoot>
								<tr>
									<th class="tc1" scope="row"><?php echo $lang['th']; ?></th>
									<th class="tc3" scope="row"><input type="submit" value="<?php echo $lang['delete']; ?>" name="supprimer" tabindex="<?php echo $tabindex++; ?>" /></th>
								</tr>
							</tfoot>
							<tbody>
							<?php
							// On pourrait utiliser la fonction glob() (plus courte), mais elle ne fonctionne pas sous free. Pour les non-utilisateurs de free, vous pouvez, si vous le sentez, remplacer le bout de code jusqu' closedir($open) par :
							// $dir = 'img/members/'.$id.'/*.{jpg,jpeg,gif,png}';
							// $files = glob($dir,GLOB_BRACE);
							$dir = 'img/members/'.$id.'/';
							if(is_dir($dir)) // On vrifie que la valeur est un fichier (pour carter les sous dossiers)
							{
								$open = opendir($dir); // On ouvre le rpertoire
								while(false !== ($file = readdir($open))) // Tant qu'il y a des fichiers  lire
								{
									if(is_file($dir.$file)) // On vrifie que la valeur est un fichier (pour carter les sous dossiers)
									{
										$extension = strtolower(substr(strrchr($file,  "." ), 1)); // On prend l'extension du fichier dans la variable $extension avec une sous-chaine
										$extsupport = explode(',', $pun_config['o_uploadile_laws'].','.strtoupper($pun_config['o_uploadile_laws'])); // La liste des extensions possibles pour une image
										if(in_array($extension, $extsupport) and ($file[0] != "#")) // Si l'extension ne figure pas dans la liste on passe le fichier (A noter: Pour cacher une image placez un "#" devant son nom et elle ne passera pas cette tape et ne sera pas liste)
											$files[] = $dir.$file; // Si elle y figure on ajoute le fichier  l'array $files
									}
								}
								closedir($open); // Et enfin on ferme le dossier
								if(isset($files))
								{
									$boucle_id = 1;
									foreach($files as $image)
									{
										$nom_image_brut = preg_replace('`img/members/'.$id.'/(.+)`','$1',$image);
										$nom_image = preg_replace('`(.+)\..*`', '$1', $nom_image_brut);
										$type_image = preg_replace('`.*\.(.+)`', '$1', $nom_image_brut);
										$size_image = ceil((filesize($image)*1024)/1048576);
										?>
										<tr>
											<td class="tc1"><a href="<?php echo $image; ?>"><?php echo $nom_image; ?></a> [<?php echo $size_image; ?>Ko][<?php echo $type_image; ?>]</th>
											<td class="tc3"><input type="checkbox" name="supprimer_<?php echo $boucle_id++; ?>" value="<?php echo $nom_image_brut; ?>" tabindex="<?php echo $tabindex++; ?>" /></td>
										</tr>
										<?php
									}
								}
								else
									echo '<tr><td colspan="2">'.$lang['err_1'].'</td></tr>';
							}
							else
								echo '<tr><td colspan="2">'.$lang['err_2'].'</td></tr>';
							?>
							</tbody>
						</table>
						<input type="hidden" name="boucle_id" value="<?php echo $boucle_id; ?>" />
					</div>
				</div>
			</form>
		</div>
	</div>
<?php
}